]> rtime.felk.cvut.cz Git - git.git/blob - git-stash.sh
Merge branch 'jc/stash-create'
[git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 USAGE='[ | list | show | apply | clear]'
5
6 SUBDIRECTORY_OK=Yes
7 . git-sh-setup
8 require_work_tree
9 cd_to_toplevel
10
11 TMP="$GIT_DIR/.git-stash.$$"
12 trap 'rm -f "$TMP-*"' 0
13
14 ref_stash=refs/stash
15
16 no_changes () {
17         git diff-index --quiet --cached HEAD &&
18         git diff-files --quiet
19 }
20
21 clear_stash () {
22         if current=$(git rev-parse --verify $ref_stash 2>/dev/null)
23         then
24                 git update-ref -d $ref_stash $current
25         fi
26 }
27
28 create_stash () {
29         stash_msg="$1"
30
31         if no_changes
32         then
33                 exit 0
34         fi
35
36         # state of the base commit
37         if b_commit=$(git rev-parse --verify HEAD)
38         then
39                 head=$(git log --abbrev-commit --pretty=oneline -n 1 HEAD)
40         else
41                 die "You do not have the initial commit yet"
42         fi
43
44         if branch=$(git symbolic-ref -q HEAD)
45         then
46                 branch=${branch#refs/heads/}
47         else
48                 branch='(no branch)'
49         fi
50         msg=$(printf '%s: %s' "$branch" "$head")
51
52         # state of the index
53         i_tree=$(git write-tree) &&
54         i_commit=$(printf 'index on %s\n' "$msg" |
55                 git commit-tree $i_tree -p $b_commit) ||
56                 die "Cannot save the current index state"
57
58         # state of the working tree
59         w_tree=$( (
60                 rm -f "$TMP-index" &&
61                 cp -p ${GIT_INDEX_FILE-"$GIT_DIR/index"} "$TMP-index" &&
62                 GIT_INDEX_FILE="$TMP-index" &&
63                 export GIT_INDEX_FILE &&
64                 git read-tree -m $i_tree &&
65                 git add -u &&
66                 git write-tree &&
67                 rm -f "$TMP-index"
68         ) ) ||
69                 die "Cannot save the current worktree state"
70
71         # create the stash
72         if test -z "$stash_msg"
73         then
74                 stash_msg=$(printf 'WIP on %s' "$msg")
75         else
76                 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
77         fi
78         w_commit=$(printf '%s\n' "$stash_msg" |
79                 git commit-tree $w_tree -p $b_commit -p $i_commit) ||
80                 die "Cannot record working tree state"
81 }
82
83 save_stash () {
84         stash_msg="$1"
85
86         if no_changes
87         then
88                 echo >&2 'No local changes to save'
89                 exit 0
90         fi
91         test -f "$GIT_DIR/logs/$ref_stash" ||
92                 clear_stash || die "Cannot initialize stash"
93
94         create_stash "$stash_msg"
95
96         # Make sure the reflog for stash is kept.
97         : >>"$GIT_DIR/logs/$ref_stash"
98
99         git update-ref -m "$stash_msg" $ref_stash $w_commit ||
100                 die "Cannot save the current status"
101         printf >&2 'Saved "%s"\n' "$stash_msg"
102 }
103
104 have_stash () {
105         git rev-parse --verify $ref_stash >/dev/null 2>&1
106 }
107
108 list_stash () {
109         have_stash || return 0
110         git log --pretty=oneline -g "$@" $ref_stash |
111         sed -n -e 's/^[.0-9a-f]* refs\///p'
112 }
113
114 show_stash () {
115         flags=$(git rev-parse --no-revs --flags "$@")
116         if test -z "$flags"
117         then
118                 flags=--stat
119         fi
120         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@")
121
122         w_commit=$(git rev-parse --verify "$s") &&
123         b_commit=$(git rev-parse --verify "$s^") &&
124         git diff $flags $b_commit $w_commit
125 }
126
127 apply_stash () {
128         git diff-files --quiet ||
129                 die 'Cannot restore on top of a dirty state'
130
131         unstash_index=
132         case "$1" in
133         --index)
134                 unstash_index=t
135                 shift
136         esac
137
138         # current index state
139         c_tree=$(git write-tree) ||
140                 die 'Cannot apply a stash in the middle of a merge'
141
142         # stash records the work tree, and is a merge between the
143         # base commit (first parent) and the index tree (second parent).
144         s=$(git rev-parse --revs-only --no-flags --default $ref_stash "$@") &&
145         w_tree=$(git rev-parse --verify "$s:") &&
146         b_tree=$(git rev-parse --verify "$s^1:") &&
147         i_tree=$(git rev-parse --verify "$s^2:") ||
148                 die "$*: no valid stashed state found"
149
150         unstashed_index_tree=
151         if test -n "$unstash_index" && test "$b_tree" != "$i_tree"
152         then
153                 git diff-tree --binary $s^2^..$s^2 | git apply --cached
154                 test $? -ne 0 &&
155                         die 'Conflicts in index. Try without --index.'
156                 unstashed_index_tree=$(git-write-tree) ||
157                         die 'Could not save index tree'
158                 git reset
159         fi
160
161         eval "
162                 GITHEAD_$w_tree='Stashed changes' &&
163                 GITHEAD_$c_tree='Updated upstream' &&
164                 GITHEAD_$b_tree='Version stash was based on' &&
165                 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
166         "
167
168         if git-merge-recursive $b_tree -- $c_tree $w_tree
169         then
170                 # No conflict
171                 if test -n "$unstashed_index_tree"
172                 then
173                         git read-tree "$unstashed_index_tree"
174                 else
175                         a="$TMP-added" &&
176                         git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
177                         git read-tree --reset $c_tree &&
178                         git update-index --add --stdin <"$a" ||
179                                 die "Cannot unstage modified files"
180                         rm -f "$a"
181                 fi
182                 git status || :
183         else
184                 # Merge conflict; keep the exit status from merge-recursive
185                 status=$?
186                 if test -n "$unstash_index"
187                 then
188                         echo >&2 'Index was not unstashed.'
189                 fi
190                 exit $status
191         fi
192 }
193
194 # Main command set
195 case "$1" in
196 list)
197         shift
198         if test $# = 0
199         then
200                 set x -n 10
201                 shift
202         fi
203         list_stash "$@"
204         ;;
205 show)
206         shift
207         show_stash "$@"
208         ;;
209 apply)
210         shift
211         apply_stash "$@"
212         ;;
213 clear)
214         clear_stash
215         ;;
216 create)
217         if test $# -gt 0 && test "$1" = create
218         then
219                 shift
220         fi
221         create_stash "$*" && echo "$w_commit"
222         ;;
223 help | usage)
224         usage
225         ;;
226 *)
227         if test $# -gt 0 && test "$1" = save
228         then
229                 shift
230         fi
231         save_stash "$*" && git-reset --hard
232         ;;
233 esac